// Autor: Ante Derek

#include <iostream>
#include <string>
#include <cstring>

using namespace std;

const int MAXN = 300;

int n, m;
string g[MAXN+2];
int d[MAXN][MAXN];

inline int valid(int x, int y) {
  if (x < 0 || x >= n)
    return 0;
  if (y < 0 || y >= m)
    return 0;
  return 1;
}

int dfs(int x, int y) {
  if (d[x][y])
    return 0;
  d[x][y] = 1;
  if (g[x][y] != '.')
    return 1;
  int total = 2;
  if (valid(x-1, y)) total += dfs(x-1, y);
  if (valid(x+1, y)) total += dfs(x+1, y);
  if (valid(x, y-1)) total += dfs(x, y-1);
  if (valid(x, y+1)) total += dfs(x, y+1);
  if (valid(x-1, y-1) && (g[x-1][y] != '/' || g[x][y-1] != '/')) total += dfs(x-1, y-1);
  if (valid(x-1, y+1) && (g[x-1][y] != '\\' || g[x][y+1] != '\\')) total += dfs(x-1, y+1);
  if (valid(x+1, y-1) && (g[x+1][y] != '\\' || g[x][y-1] != '\\')) total += dfs(x+1, y-1);
  if (valid(x+1, y+1) && (g[x+1][y] != '/' || g[x][y+1] != '/')) total += dfs(x+1, y+1);
  return total;
}

int main() {
  cin >> n >> m;
  n += 2;
  m += 2;
  g[0] = string(m, '.');
  for (int i=1; i<n-1; i++) {
    string x;
    cin >> x;
    g[i] = '.'+x+'.';
  }
  g[n-1] = string(m, '.');
  memset(d, 0, sizeof d);
  cout << m*n-dfs(0, 0)/2 << endl;
  return 0;
}
