// Autor: Goran Zuzic

#include <algorithm>

#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <string>
#include <vector>
#include <iostream>

using namespace std;

const int MAXN = 20;

int main(void)
{
  int R, S; scanf("%d %d", &R, &S);
  char grid[MAXN][MAXN+1]; memset(grid, '.', sizeof grid);

  for (int i = 0; i < R; ++i)
    scanf("%s", grid[i+10]);
  R += 10;

  int first[MAXN];
  for (int j = 0; j < S; ++j) {
    first[j] = R;
    for (int i = 0; i < R; ++i)
      if (grid[i][j] == 'x') {
        first[j] = i; 
        break;
      }
  }

  vector<int> output;

  while (true) {
    bool done = true;
    for (int j = 0; j < S; ++j)
      if (first[j] < R-3)
        done = false;
    if (done) break;

    int max_s = 0;
    for (int j = 0; j < S; ++j)
      if (first[j] > first[max_s])
        max_s = j;

    output.push_back(max_s);
    for (int d = 0; d < 4; ++d) {
      assert(first[max_s] > 0);
      grid[first[max_s] - 1][max_s] = 'x';
      --first[max_s];
    }

    for (int r = 0; r < R; ++r) {
      bool empty = true;
      for (int s = 0; s < S; ++s)
        if (grid[r][s] == '.')
          empty = false;

      if (empty) {
        for (int s = 0; s < S; ++s) {
          for (int i = r; i > 0; --i)
            grid[i][s] = grid[i-1][s];
          grid[0][s] = '.';
          while (first[s] < R && grid[first[s]][s] == '.')
            ++first[s];
        }
      }
    }
  }

  printf("%d\n", (int)output.size());
  for (int i = 0; i < (int)output.size(); ++i)
    printf("%d\n", output[i]+1);

  return 0;
}
